#include <cstdlib>
#include <iostream>

#pragma clang diagnostic push

#pragma clang diagnostic ignored "-Wsign-conversion"
#pragma clang diagnostic ignored "-Wold-style-cast"
#pragma clang diagnostic ignored "-Wparentheses"
#pragma clang diagnostic ignored "-Wcast-qual"
#pragma clang diagnostic ignored "-Wdeprecated"
#pragma clang diagnostic ignored "-Wconversion"
#pragma clang diagnostic ignored "-Wreserved-id-macro"
#pragma clang diagnostic ignored "-Wweak-vtables"
#pragma clang diagnostic ignored "-Wundef"
#pragma clang diagnostic ignored "-Wzero-as-null-pointer-constant"
#pragma clang diagnostic ignored "-Wundefined-func-template"
#pragma clang diagnostic ignored "-Wc++98-compat"
#pragma clang diagnostic ignored "-Wc++98-compat-pedantic"
#pragma clang diagnostic ignored "-Wexit-time-destructors"
#pragma clang diagnostic ignored "-Wpadded"
#pragma clang diagnostic ignored "-Wnon-virtual-dtor"
#pragma clang diagnostic ignored "-Wsuggest-override" // added in 2021!
#pragma clang diagnostic ignored "-Wsuggest-destructor-override" // added in 2021!
#pragma clang diagnostic ignored "-Wc11-extensions" // added in 2021!
#pragma clang diagnostic ignored "-Winconsistent-missing-destructor-override"  // added in 2021!
#pragma clang diagnostic ignored "-Wunsafe-buffer-usage" // added in 2024!

#include "boost/exception/diagnostic_information.hpp"
#include "boost/filesystem.hpp"

#pragma clang diagnostic pop


int main()
{
    try
    {
        boost::filesystem::path source_path("/Codes/ThirdPartyWarning/source.txt");
        boost::filesystem::path target_path("target.txt");

        boost::filesystem::copy_file(source_path, target_path);
    }
    catch (const boost::filesystem::filesystem_error& e)
    {
        std::cerr << "Exception with Boost filesystem: " << boost::diagnostic_information(e) << std::endl;
        return EXIT_FAILURE;
    }
    
    int a; // variable intentionally left to underline my point about warnings...
    
    std::cout << "Value is " << a << std::endl;
    
    return EXIT_SUCCESS;
}
